# OSMesaWithGLEW

This package contains precompiled binaries for OSMesa and GLEW that have been compiled to work together.

# Building binaries for updating the package

choco install python3 winflexbison3 pkgconfiglite

(Python >= 3.7 required!)

pip3 install meson

pip3 install ninja

pip3 install mako

# Building OSMesa (softpipe, SLOW!)

meson buildDebugX86 -Dosmesa=true -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildDebugX86/install --cross-file crossx86dbg.txt -Dbuildtype=debug

meson buildReleaseX86 -Dosmesa=true -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildReleaseX86/install --cross-file crossx86.txt -Dbuildtype=release

meson buildDebugX64 -Dosmesa=true -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildDebugX64/install --cross-file crossx64dbg.txt -Dbuildtype=debug

meson buildReleaseX64 -Dosmesa=true -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildReleaseX64/install --cross-file crossx64.txt -Dbuildtype=release

meson compile -C buildDebugX86

meson compile -C buildReleaseX86

meson compile -C buildDebugX64

meson compile -C buildReleaseX64

ninja -C buildDebugX86 install

ninja -C buildReleaseX86 install

ninja -C buildDebugX64 install

ninja -C buildReleaseX64 install

OR

# Building LLVM with MSVC

get llvm 7.1.0 sources

fix /include/llvm/support/ManagedStatic.h by overwriting with version from /assets dir

run CMake and set the following vars:

| Name | Type | Value (64 bit builds) | Value (32 bit builds) |
| :- | :- | :-: | :-: |
| LLVM_DEFAULT_TARGET_TRIPLE | STRING | x86_64-pc-windows-msvc19 | i686-pc-win32 |
| LLVM_HOST_TRIPLE | STRING | x86_64-pc-windows | i686-pc-win32 |
| LLVM_TARGETS_TO_BUILD | STRING | X86 | X86 |
| LLVM_TARGET_ARCH | STRING | x86_64 | i686 |
| LLVM_USE_CRT_DEBUG | STRING | MDd | MDd |
| LLVM_USE_CRT_RELEASE | STRING | MD | MD |

configure (switch off unnecessary LLVM_BUILD_* and LLVM_INCLUDE_*, only need RUNTIME and RUNTIMES)

generate

build

OR use precompiled libs: https://github.com/vovkos/llvm-package-windows/releases/llvm-7.1.0

# Building OSMesa (llvmpipe, FAST!)

create directory /mesa/subprojects/llvm/

copy /include and /lib directories from llvm binary dirs to /mesa/subprojects/llvm and rename the lib dirs thusly:

| build configuration | subdirectory |
| :- | :- |
| x86 Release | lib | 
| x86 Debug | libDbg |
| x64 Release | lib64 |
| x64 Debug | lib64Dbg |

add meson.build file from /assets folder to /subprojects/llvm, make sure libs have right name (e.g. without lib* prefix)

copy cross*.txt files from /assets folder into /mesa

fix filepaths to CL and Windows SDKs in crossx86*.txt files

meson buildDebugX86 -Dosmesa=true -Dllvm=true -Dopengl=false -Dzlib=disabled -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildDebugX86/install --cross-file crossx86dbg.txt -Dbuildtype=debug

meson buildReleaseX86 -Dosmesa=true -Dllvm=true -Dopengl=false -Dzlib=disabled -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildReleaseX86/install --cross-file crossx86.txt -Dbuildtype=release

meson buildDebugX64 -Dosmesa=true -Dllvm=true -Dopengl=false -Dzlib=disabled -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildDebugX64/install --cross-file crossx64dbg.txt -Dbuildtype=debug

meson buildReleaseX64 -Dosmesa=true -Dllvm=true -Dopengl=false -Dzlib=disabled -Dgallium-drivers=swrast -Ddri-drivers=[] -Dvulkan-drivers=[] -Dprefix=$PWD/buildReleaseX64/install --cross-file crossx64.txt -Dbuildtype=release

meson compile -C buildDebugX86

meson compile -C buildReleaseX86

meson compile -C buildDebugX64

meson compile -C buildReleaseX64

ninja -C buildDebugX86 install

ninja -C buildReleaseX86 install

ninja -C buildDebugX64 install

ninja -C buildReleaseX64 install

# Building glew

unpack source snapshot (some code is not included in repo but generated by Perl script at compile time, this is not easily supported with MSVC toolchain, so better use pregenerated versions in snapshot)

use (potentially update) VS solution file

configure glew_static

- add GLEW_OSMESA compile definition
- add include dir: mesa/builddir/install/includes
- set runtime linkage type

build glew_static target
